# super 1 at 75% HP : Iceberg Fall - 4 Icebergs crashes down into the arena, dealing damage where it lands and dissipating cold energy that slows nearby ally units.
#        These Icebergs can be destroyed by both the player's attacks and Kaldrmir's, but upon destruction, the Iceberg explodes, releashing shrapnel of icicles.
#        Any Kaldrmir's attacks will one-shot the Iceberg.

# Super 2 at 50% HP : Storms Over Andurvil - Kaldrmir flies upwards. Creates a giant crystal on the center that upon destruction, will deploy
#                   A shield that protects allies from Kaldrmir's ultimate showering attack.

# Rimewind - blows cold winds to towards the arena, sending forth sharp icicles towards a random area.

#hp
execute if score worldScore wtc_4 matches 3.. as @e[tag=kaldrmir_hitbox,type=slime] run function ampsurv:boss/kaldrmir/system/hurtbox/operation
#execute store result score kaldrmir boss.storage.kaldrmir run data get entity @e[tag=kaldrmir_entity,limit=1,sort=nearest,type=slime] Health

#display bar
execute if score worldScore wtc_4 matches 3.. store result bossbar minecraft:bosshp15 value run scoreboard players get kaldrmir boss.storage.kaldrmir

#hitboxes
function ampsurv:boss/kaldrmir/system/hurtbox/tp

# score add and score resets
scoreboard players add kaldrmir boss.battle_tick 1
execute if entity @e[tag=kaldrmir_entity,type=slime,distance=..100] if entity @s[tag=!dying] if score kaldrmir boss.battle_tick matches 500.. run scoreboard players set kaldrmir boss.battle_tick 1
execute if score kaldrmir boss.battle_tick matches 250 run tag @e remove kaldrmir_target
execute if score kaldrmir boss.battle_tick matches 499 run tag @e remove kaldrmir_target

#random roars
execute if score kaldrmir boss.battle_tick matches 250 run playsound minecraft:boss.kaldrmir.sfx.normal_roar hostile @a[distance=..100] ~ ~ ~ 1 1 0.3
execute if score kaldrmir boss.battle_tick matches 499 run playsound minecraft:boss.kaldrmir.sfx.growl_normal hostile @a[distance=..100] ~ ~ ~ 1 1 0.3

#hurt
execute if entity @e[tag=kaldrmir_hitbox,tag=hurt,type=slime] run playsound minecraft:entity.wither.hurt hostile @a[distance=..100] ~ ~ ~ 1 0 0.1

# boss.storage2 animation cooldown
execute if score kaldrmir boss.storage2 matches 1.. run scoreboard players remove kaldrmir boss.storage2 1
# boss.storage1 attack cooldown
execute if score kaldrmir boss.storage1 matches 1.. run scoreboard players remove kaldrmir boss.storage1 1

#music
execute if score kaldrmir boss.kaldrmir.music matches 1.. run scoreboard players remove kaldrmir boss.kaldrmir.music 1
execute if score kaldrmir boss.kaldrmir.music matches 0 run playsound minecraft:boss.kaldrmir.theme.start record @a[distance=..100] ~ ~ ~ 0.7 1 0.7
execute if score kaldrmir boss.kaldrmir.music matches 0 run scoreboard players set kaldrmir boss.kaldrmir.music 5240

#targetting system
execute as @e[tag=kaldrmir_entity,type=slime] at @s if score worldScore wtc_10 matches 9.. run function ampsurv:boss/kaldrmir/system/targetting

# attack randomizer
execute if score worldScore wtc_4 matches 3.. if score kaldrmir ally.anim_tick matches ..5 run scoreboard players add kaldrmir ally.anim_tick 1
execute if score worldScore wtc_10 matches 9.. if score kaldrmir ally.anim_tick matches 5.. run scoreboard players set kaldrmir ally.anim_tick 0

#idle animation in battle
execute if score kaldrmir boss.battle_tick matches 1.. if score kaldrmir boss.storage2 matches ..0 if entity @e[tag=aj.kaldrmir.root,tag=!attack,tag=!dying] run execute as @e[tag=aj.kaldrmir.root,type=marker] at @s run function kaldrmir:animations/flying_inplace_loop/next_frame
tp @s[tag=!attack,tag=!dying] ~ ~ ~ facing entity @e[type=#ally,tag=kaldrmir_target,limit=1,sort=nearest]

#choose attack
execute if score kaldrmir boss.battle_tick matches 1.. if score kaldrmir boss.storage2 matches ..0 if score kaldrmir boss.storage1 matches ..0 if entity @e[tag=aj.kaldrmir.root,tag=!attack,tag=!dying,tag=!iceberg_next,tag=!sp_next] run execute as @e[tag=aj.kaldrmir.root,type=marker] at @s run function ampsurv:boss/kaldrmir/system/phases/attackphases/manager

#loops
function ampsurv:boss/kaldrmir/attacks/projectile/manager
function ampsurv:boss/kaldrmir/attacks/hitbox/manager
execute if entity @s[tag=ground_strike] run function ampsurv:boss/kaldrmir/attacks/ground/groundstrike/loop
execute if entity @s[tag=aj.kaldrmir.anim.rimewind_attack] run function ampsurv:boss/kaldrmir/attacks/flying/rimewind/loop
execute if entity @s[tag=aj.kaldrmir.anim.iceberg] run function ampsurv:boss/kaldrmir/attacks/flying/iceberg/anim-loop
execute if entity @s[tag=aj.kaldrmir.anim.flyby_frostbreath] run function ampsurv:boss/kaldrmir/attacks/flying/flyby_breath/loop
execute if entity @s[tag=iceberg_next] run function ampsurv:boss/kaldrmir/attacks/flying/iceberg/wait
execute if entity @s[tag=sp_next] run function ampsurv:boss/kaldrmir/attacks/flying/sp/wait


#anim resets
#execute if entity @s[tag=attack] if score kaldrmir boss.storage2 matches ..1 run function ampsurv:boss/kaldrmir/anim-reset

#percent detections
#75%
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=!75_percent] if score kaldrmir boss.storage.kaldrmir matches ..600 run function ampsurv:boss/kaldrmir/system/phases/detect/75
#50%
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=!50_percent] if score kaldrmir boss.storage.kaldrmir matches ..400 run function ampsurv:boss/kaldrmir/system/phases/detect/50

# re-cast Iceberg if there are no icebergs left (only if kaldrmir is on 50% hp phase)
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=50_percent,tag=!dying,tag=!attack,tag=!iceberg_next,tag=!sp_next] at @e[tag=kaldrmir_battle_center,type=marker] unless entity @e[tag=kaldrmir_iceberg,distance=..60,type=armor_stand] run tag @s add iceberg_next 

#death ------------------------------------
# check
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=!dying,tag=scened] if score kaldrmir boss.storage.kaldrmir matches ..1 run tellraw @a[distance=..100] ["",{"text":"\n"},{"text":"\u1360","color":"dark_red"},{"text":" Kaldrmir","bold":true,"color":"red"},{"text":" has been defeated!","color":"dark_red"},{"text":"\n "}]
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=!dying,tag=scened] if score kaldrmir boss.storage.kaldrmir matches ..1 run scoreboard players set kaldrmir boss.battle_tick 611
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=!dying,tag=scened] if score kaldrmir boss.storage.kaldrmir matches ..1 run tag @s add dying
# loop
execute as @e[tag=aj.kaldrmir.root,type=marker,tag=dying,tag=scened] at @s run function ampsurv:boss/kaldrmir/system/defeat

